<template>
    <div class='sm:h-screen sm:flex items-center sm:bg-xmas-gray sm:px-5'>
        <div class='max-w-7xl mx-auto font-mont sm:flex min-h-100 w-full'>
            <div class='bg-xmas-red flex-1 items-center flex justify-center py-6 sm:py-0 sm:rounded-l-lg sm:shadow-md flex-shrink-0'>
                <img :src="'images/logo-inverted.png'" alt='Logo' class='w-64 sm:w-96' />
            </div>
            <div class='flex-1 flex-shrink-0 pt-10 pb-24 sm:rounded-r-lg bg-white sm:shadow-md relative'>
                <transition name="fade" mode="out-in">
                    <div class='mx-6 sm:mx-14'>
                        <p class='text-4xl sm:text-5xl font-bold text-xmas-gray sm:text-center'>Вход</p>
                        <p class='text-sm mt-10 text-center'>Въведи своя идентификационен хеш (фенси, а?)</p>
                        <p class='text-xs text-center mt-4'>Алтернативно, можеш да влезеш без тези занимавки, използвайки линка от мейлът за потвърждение.</p>
                        <div class='mt-8'>
                            <Text v-model='form.hash' @blur="v$.form.hash.$touch()" :invalid="v$.form.hash.$error" label="Идентификационен хеш" required></Text>
                            <p class='text-xs mt-4 text-xmas-red'>{{ error }}</p>
                            <ButtonStack :disabled="v$.$invalid || v$.$pending" @click='attemptLogin' label="Влизам"></ButtonStack>
                        </div>
                    </div>                    
                </transition>
            </div>
        </div>        
    </div>
</template>
<script>
    import Text from '@/components/Text'
    import ButtonStack from '@/components/ButtonStack'
    import useVuelidate from '@vuelidate/core'    
    import { required, minLength, maxLength } from '@vuelidate/validators'    

    export default {
        name: 'Login',
        components: {
            Text,
            ButtonStack,
        },
        data() {
            return {
                form: {
                    hash: null,
                },
                error: null,
            }
        },
        mounted() {
            this.$store.dispatch("main/stopLoading");
        },
        setup() {
            return { v$: useVuelidate() }
        },
        methods: {
            attemptLogin() {
            this.$store.dispatch("main/startLoading");
                axios.get('sanctum/csrf-cookie').then((r) => {
                    axios.post('/api/login', this.form).then((r) => {
                        if(r.data) {
                            this.error = 'Не намираме такъв хеш. Провери в мейла, получен от нас или просто клинки на линка от там.'
                        } else {
                            this.$router.push('/dashboard');
                        }
                    })
                })
            }
        },
        validations: {
            form: {
                hash: {
                    required,
                    minLength: minLength(7),
                    maxLength: maxLength(7),
                }
            }
        }
    }
</script>